//	ATtiny2313
//	7ZO4{[hp
//	
//	v	\LCDp
//	EJ_[F^ɑΉ
//	EvF12^24ԐɑΉ
//	E\[h^ݒ胂[h

/*
|[gΉ	[ATtiny2313]	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	-	clk
portB	swL	swR	-	-	-	PWM	-	LCD		XCb`APWM(OC0A:obNCg)ALCDڑ
portD	x	LCD	PWM	LCD	LCD	LCD	LCD	LCD		LCDڑAPWM(OC0B:RgXg)

q[Yrbg
Low: 01100000
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

rh
WinAVR-20080610		œKIvV:-Os
ATtiny2313	11.776MHz/8(1.472MHz)


2010/02/05	v1.00	Program:    1888 bytes (92.2% Full)
					Data:         19 bytes (14.8% Full)
				ELCDClockP ver0.03+x[Xɉ
*/

//------------------------------------------------------------
//	{[h̃^Cv	1:J\[hR 0:Am[hR
#define	_CATHODE_CMN_	0
//------------------------------------------------------------

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/pgmspace.h>
#include	"lcdlib.h"
#include	"font5x8.h"


//샂[h
enum	E_OPMODE
{
	OP_CLOCK,		//v\
	OP_ADJ_SEC,		//b
	OP_ADJ_MIN,		//
	OP_ADJ_HOUR,	//
	OP_ADJ_YEAR_10,	//Ni\̈ʁj
	OP_ADJ_YEAR_1,	//Nïʁj
	OP_ADJ_MONTH,	//
	OP_ADJ_DAY,		//
	OP_ADJ_WEEK,	//j
	OP_ADJ_CONTRAST,	//RgXg
	OP_ADJ_BACKLIGHT	//obNCg
};

//̍ŏIi邤N͍lȂj
const	prog_uint8_t	LAST_DAY[]	= { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

//\[h
//bit1:	0	0	1	1	c 0:24Ԑ	1:12Ԑ
//bit0:	0	1	0	1	c 0:		1:
//	l	0	1	2	3
#define	DISPMODE_GENGOU	0x01
#define	DISPMODE_HOUR12	0x02

//`XVv̓e
#define	UPDT_DATE	0x01
#define	UPDT_TIME	0x02

//LCDł̕\ʒu
//		0123456789ABCDEF
//date	2000Y00M00D(W)
//time	A00:00:00
#define	POS_DATE_X	0
#define	POS_DATE_Y	0
#define	POS_TIME_X	0
#define	POS_TIME_Y	1
#define	POS_ADJ_YY	(POS_DATE_X + 2)
#define	POS_ADJ_YY1	(POS_ADJ_YY + 1)
#define	POS_ADJ_MM	(POS_ADJ_YY1 + 3)
#define	POS_ADJ_DD	(POS_ADJ_MM + 3)
#define	POS_ADJ_WK	(POS_ADJ_DD + 3)
#define	POS_ADJ_H	(POS_TIME_X + 2)
#define	POS_ADJ_M	(POS_ADJ_H + 3)
#define	POS_ADJ_S	(POS_ADJ_M + 3)
#define	POS_ADJ_CON	(POS_ADJ_S + 1)
#define	POS_ADJ_BKL	(POS_ADJ_CON + 1)

//ݒ蒆̈ē
#define	ADJ_INFO	"Adj."
#define	POS_INFO_X	12	//16 - sizeof(ADJ_INFO)
#define	POS_INFO_Y	1

//ݒ蒆PWMl̕\ʒu
#define	POS_PWM_X	14	//16 - 2

//LCD[U[`iLN^R[hj
enum	E_LCD_GAIJI
{
	LCD_GAIJI_YEAR	= 0x00,
	LCD_GAIJI_MONTH,
	LCD_GAIJI_DAY,
	LCD_GAIJI_WEEK,
	LCD_GAIJI_HEI,
	LCD_GAIJI_SEI,
	LCD_GAIJI_AM,
	LCD_GAIJI_PM
};

//----------------------------------------------------------------------
//	lcdlib.cg֐A}N
//----------------------------------------------------------------------

static	uint8_t	data[8] = {0};

//lcdDefChar()̃vÖΉ
void	lcdDefCharP(uint8_t id, uint8_t eidx)
{
	uint8_t	i;
	for (i = 0; i < 8; i++)
		data[i] = pgm_read_byte(&dots[eidx][i]);
	lcdDefChar(id, data);
}

//ݒ胂[hւ̈ڍsAA
#define	lcdAdjModeOn()	lcdCmd(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY | LCD_SUBCMD_SET_CURSOR)
#define	lcdAdjModeOff()	lcdCmd(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY)

//1̕Ȃ
#define	lcdPutInt1(n)	lcdPutChar('0' + (n))

//2̕Ȃ
void	lcdPutInt2(uint8_t n, uint8_t pad)
{
	if (n < 10)
	{
		lcdPutChar(pad);
		lcdPutInt1(n);
	}
	else
	{
		lcdPutInt1(n / 10);
		lcdPutInt1(n % 10);
	}
}

//0l2̕Ȃ
void	lcdPutInt02(uint8_t n)
{
	lcdPutInt2(n, '0');
}

//󔒋l2̕Ȃ
void	lcdPutIntSP2(uint8_t n)
{
	lcdPutInt2(n, ' ');
}

//0l216i
const	prog_uint8_t	HEX_CHAR[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
void	lcdPutHex02(uint8_t	n)
{
	lcdPutChar(pgm_read_byte(&HEX_CHAR[(n >> 4) & 0x0F]));
	lcdPutChar(pgm_read_byte(&HEX_CHAR[n & 0x0F]));
}

//----------------------------------------------------------------------

//t\iNj
void	displayDateYear(uint8_t year, uint8_t dispMode)
{
	if (dispMode & DISPMODE_GENGOU)
	{
		lcdPutChar(LCD_GAIJI_HEI);
		lcdPutChar(LCD_GAIJI_SEI);
		lcdPutInt02(year + 12);
	}
	else
	{
		lcdPutInt02(20);
		lcdPutInt02(year);
	}
}

//t\
void	displayDate(uint8_t year, uint8_t dispMode, uint8_t month, uint8_t day, uint8_t week)
{
	displayDateYear(year, dispMode);
	lcdPutChar(LCD_GAIJI_YEAR);
	
	lcdPutIntSP2(month);
	lcdPutChar(LCD_GAIJI_MONTH);
	
	lcdPutIntSP2(day);
	lcdPutChar(LCD_GAIJI_DAY);
	
	lcdPutChar('(');
	lcdPutChar(LCD_GAIJI_WEEK);
	lcdPutChar(')');
}

//\ij
void	displayTimeHour(uint8_t ampm, uint8_t hour)
{
	lcdPutChar(ampm);
	lcdPutIntSP2(hour);
}

//\
void	displayTime(uint8_t ampm, uint8_t hour, uint8_t min, uint8_t sec)
{
	displayTimeHour(ampm, hour);
	lcdPutChar(':');
	
	lcdPutInt02(min);
	lcdPutChar(':');
	
	lcdPutInt02(sec);
}

//PWM
//RgXg̍ől
#define	PWM_CON_MAX		0x80	//0x80𒴂ƕ\ČȂȂ

//荞ݔʒmtOiWX^R2Ɋtj
volatile	register	uint8_t	bTC	asm("r2");

//16bit^C}	1(sec)Ƃ̌Ăяo
ISR(TIMER1_COMPA_vect)
{
	bTC = 1;
}


int	main(void)
{
	uint8_t	year, month, day, week;		//2AAAji0-67jj
	uint8_t	hour24, hour, min, sec;		//i24ԁjAi\pjAb
	uint8_t	ampm;						//ߑO^ߌ
	uint8_t	opMode, dispMode;			//샂[hA\[h
	uint8_t	doUpdate;		//`XVtO
	uint8_t	sw, psw;		//XCb`ǂݎ
	uint8_t	swL, swR;		//XCb`̏	1:on	0:off
	uint8_t	loopCnt;		//^C~O҂ȂǂɎgJE^
	uint8_t	pwmCon, pwmBkLt;	//PWMFRgXgAobNCg
	
	year = 0;
	month = day = 1;
	week = 0;
	hour24 = hour = min = sec = 0;
	ampm = ' ';
	opMode = OP_CLOCK;
	dispMode = 0;
	doUpdate = UPDT_DATE | UPDT_TIME;
	psw = sw = 0;
	loopCnt = 0;
	pwmCon = 0x20;
	pwmBkLt = 0x80;
	
	//|[gݒ
	DDRB	= 0b00010101;	//LCDGND:PB4APWMo:PB2(OC0A:obNCg)ALCDɓd:PB0
//	DDRD	= 0b00100000;	//PWMo:PD5(OC0B:RgXg)	lcdlibŒ`
	PORTB	= 0b11000000;	//XCb`2:PB7-PB6
	
	//LCD
	lcdInit();
	
	//LCD[U[`o^
	lcdDefCharP(LCD_GAIJI_YEAR,	E_YEAR);
	lcdDefCharP(LCD_GAIJI_MONTH,	E_MON);
	lcdDefCharP(LCD_GAIJI_DAY,	E_SUN);
	lcdDefCharP(LCD_GAIJI_WEEK,	E_SUN);
	lcdDefCharP(LCD_GAIJI_HEI,	E_HEI);
	lcdDefCharP(LCD_GAIJI_SEI,	E_SEI);
	lcdDefCharP(LCD_GAIJI_AM,	E_AM);
	lcdDefCharP(LCD_GAIJI_PM,	E_PM);
	
	//8bit^C}[
	//8rbgPWM	TCCR0B:WGM02=0, TCCR0A:WGM01=1, TCCR0A:WGM00=1
	//rAo	񔽓]	TCCR0A:COM0A1=1, TCCR0A:COM0A0=0
	//rBo	񔽓]	TCCR0A:COM0B1=1, TCCR0A:COM0B0=0
	//(Ȃ)		TCCR0B:CS02=0, TCCR0B:CS01=0, TCCR0B:CS00=1
	TCCR0A	= (1 << COM0A1) | (0 << COM0A0) | (1 << COM0B1) | (0 << COM0B0) | (1 << WGM01) | (1 << WGM00);
	TCCR0B	= (0 << WGM02) | (0 << CS02) | (0 << CS01) | (1 << CS00);
	OCR0A = pwmBkLt;	//rl
	OCR0B = pwmCon;		//rl
	
	//16bit^C}[
	//CTC	TCCR1B:WGM12=1, TCCR1A:WGM11=0, TCCR1A:WGM10=0
	//(64)	CS12=0, CS11=1, CS10=1
	TCCR1A	= (0 << WGM11) | (0 << WGM10);
	TCCR1B	= (1 << WGM12) | (0 << CS12) | (1 << CS11) | (1 << CS10);
	OCR1A	= F_CPU / 64 - 1;	//rl	1bv
	
	//荞ݐݒ
	TIMSK	= (1 << OCIE1A);	//16bit^C}[:rv荞
	
	bTC = 0;
	sei();		//荞݋
	
	while (1)
	{
		//荞ݔiԌo߁j
		if (bTC)
		{
			bTC = 0;
			doUpdate |= UPDT_TIME;
			if (60 <= ++sec)
			{
				sec = 0;
				if (60 <= ++min)
				{
					min = 0;
					if (24 <= ++hour24)		//펞24ԐŃJEgA\iKŉH
					{
						doUpdate |= UPDT_DATE;
						hour24 = 0;
						if (7 <= ++week) week = 0;
						lcdDefCharP(LCD_GAIJI_WEEK, E_SUN + week);
						if (pgm_read_byte(&LAST_DAY[month]) < ++day)
						{
							day = 1;
							if (12 < ++month)
							{
								month = 1;
								if (100 <= ++year) year = 0;	//year͐̉2
							}
						}
					}
				}
			}
		}
		
		//\XV
		if (doUpdate & UPDT_DATE)
		{
			lcdSetPos(POS_DATE_X, POS_DATE_Y);
			displayDate(year, dispMode, month, day, week);
		}
		
		if (doUpdate & UPDT_TIME)
		{
			//nԐ̎\
			//12: 12, 1,..........,12, 1,..,11,12
			//24:  0, 1,..........,12,13,..,23, 0
			hour = hour24;
			if (dispMode & DISPMODE_HOUR12)
			{
				if (hour == 0) hour = 12;
				if (12 < hour) hour -= 12;
				//^Ƃ12:00̏uԂɌߑO^ߌ؂ւ
				ampm = (12 <= hour24) ? LCD_GAIJI_PM : LCD_GAIJI_AM;
			}
			else
			{
				//AM/PM\͋
				ampm = ' ';
			}
			
			lcdSetPos(POS_TIME_X, POS_TIME_Y);
			displayTime(ampm, hour, min, sec);
		}
		
		doUpdate = 0;
		
		//XCb`ǂݎ
		swR = swL = 0;
		if ((++loopCnt & 0x20) == 0x20)		//`^OłxɃ[vԊu󂯂
		{
			sw = PINB & 0b11000000;
			if (psw != sw)
			{
				swL = ~sw & 0b10000000;
				swR = ~sw & 0b01000000;
				psw = sw;
			}
		}
		
		//\eύX
		switch (opMode)
		{
		case OP_ADJ_YEAR_10:
			lcdSetPos(POS_ADJ_YY, POS_DATE_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_YEAR_1;
			}
			if (swR)
			{
				if (year < 90) year += 10;
				else year %= 10;
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_YEAR_1:
			lcdSetPos(POS_ADJ_YY1, POS_DATE_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_MONTH;
			}
			if (swR)
			{
				if (year % 10 < 9) year++;
				else year /= 10;
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_MONTH:
			lcdSetPos(POS_ADJ_MM, POS_DATE_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_DAY;
			}
			if (swR)
			{
				if (++month > 12) month = 1;
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_DAY:
			lcdSetPos(POS_ADJ_DD, POS_DATE_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_WEEK;
			}
			if (swR)
			{
				if (++day > 31) day = 1;	//ɂ炸31܂Őݒł
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_WEEK:
			lcdSetPos(POS_ADJ_WK, POS_DATE_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_HOUR;
			}
			if (swR)
			{
				if (++week >= 7) week = 0;
				lcdDefCharP(LCD_GAIJI_WEEK, E_SUN + week);
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_HOUR:
			lcdSetPos(POS_ADJ_H, POS_TIME_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_MIN;
			}
			if (swR)
			{
				if (++hour24 >= 24) hour24 = 0;
				doUpdate = UPDT_TIME;
			}
			break;
			
		case OP_ADJ_MIN:
			lcdSetPos(POS_ADJ_M, POS_TIME_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_SEC;
			}
			if (swR)
			{
				if (++min >= 60) min = 0;
				doUpdate = UPDT_TIME;
			}
			break;
			
		case OP_ADJ_SEC:
			lcdSetPos(POS_ADJ_S, POS_TIME_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_CONTRAST;
				lcdSetPos(0x0E, POS_DATE_Y);
				lcdPutHex02(pwmCon);
			}
			if (swR)
			{
				sec = 0;
				TCNT1 = 0;
				doUpdate = UPDT_TIME;
			}
			break;
			
		case OP_ADJ_CONTRAST:
			lcdSetPos(POS_ADJ_CON, POS_TIME_Y);
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_BACKLIGHT;
				lcdSetPos(0x0E, POS_DATE_Y);
				lcdPutHex02(pwmBkLt);
			}
			if (swR)
			{
				pwmCon += 0x10;
				if (PWM_CON_MAX < pwmCon) pwmCon = 0;
				OCR0B = pwmCon;
				
				//݂̐ݒl\
				lcdSetPos(POS_PWM_X, POS_DATE_Y);
				lcdPutHex02(pwmCon);
			}
			break;
			
		case OP_ADJ_BACKLIGHT:
			lcdSetPos(POS_ADJ_BKL, POS_TIME_Y);
			//XCb`͔
			if (swL)
			{
				//\[h֕A
				opMode = OP_CLOCK;
				lcdAdjModeOff();
				lcdCls();
				doUpdate = UPDT_DATE | UPDT_TIME;
			}
			if (swR)
			{
				if (pwmBkLt == 0xF0) pwmBkLt = 0xFF;
				else pwmBkLt += 0x10;
				if (pwmBkLt < 0x10) pwmBkLt = 0;
#if	_CATHODE_CMN_
				OCR0A = pwmBkLt;		//J\[hRp̐{[h̓gWX^NPN^
#else
				OCR0A = 0xFF - pwmBkLt;	//Am[hRp̐{[h̓gWX^PNP^
#endif
				//݂̐ݒl\
				lcdSetPos(POS_PWM_X, POS_DATE_Y);
				lcdPutHex02(pwmBkLt);
			}
			break;
			
		//case OP_CLOCK:
		default:
			//XCb`͔
			if (swL)
			{
				//ݒ胂[hp̓\ɕύX
				dispMode = 0;	//A24Ԑ
				doUpdate = UPDT_DATE | UPDT_TIME;
				
				//̑̒ڂ\
				lcdSetPos(POS_ADJ_CON, POS_TIME_Y);
				lcdPutChar('C');
				lcdPutChar('B');
				
				//ݒ胂[hֈڍs
				opMode = OP_ADJ_YEAR_10;
				lcdAdjModeOn();
				lcdSetPos(POS_INFO_X, POS_INFO_Y);
				lcdPutStr((uint8_t*)ADJ_INFO);
			}
			if (swR)
			{
				//\[hύX
				if (3 < ++dispMode) dispMode = 0;
				doUpdate = UPDT_DATE | UPDT_TIME;
			}
			break;
			
		}	//switch()

	}	//while()
	
	return 0;
}
